package com.example.dollarstroke;

import android.util.Log;
import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;
import android.widget.EditText;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ToggleButton;
import android.widget.CompoundButton;

import android.os.Handler;
import android.os.Message;

public class MainActivity extends Activity implements OnClickListener
{
	/** Used as a pulse to gradually fade the contents of the window. */
	private static final int FADE_MSG = 1;

	/** How often to fade the contents of the window (in ms). */
	private static final int FADE_DELAY = 100;

	private DollarStrokeView strokeDollarView;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		strokeDollarView= (DollarStrokeView)findViewById(R.id.dollarStrokeView1);

		findViewById(R.id.addButton).setOnClickListener(this);
		findViewById(R.id.writeXml).setOnClickListener(this);
		findViewById(R.id.recon).setOnClickListener(this);
		findViewById(R.id.clear).setOnClickListener(this);
		findViewById(R.id.clearHist).setOnClickListener(this);

		strokeDollarView.setOutputTextView((TextView)findViewById(R.id.textView1));

		// Restore the fading option if we are being thawed from a
		// previously saved state.  Note that we are not currently remembering
		// the contents of the bitmap.
		ToggleButton tglBtn = (ToggleButton)findViewById(R.id.toggleButton1);
		strokeDollarView.turnOffXY(tglBtn.isChecked());
		tglBtn.setOnCheckedChangeListener(
			new CompoundButton.OnCheckedChangeListener()
			{
				public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
				{
					strokeDollarView.turnOffXY(isChecked);
				}
			}
		);

		tglBtn = (ToggleButton)findViewById(R.id.toggleButton2);
		doFading(tglBtn.isChecked());
		tglBtn.setOnCheckedChangeListener(
			new CompoundButton.OnCheckedChangeListener()
			{
				public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
				{
					doFading(isChecked);
				}
			}
		);
		tglBtn = (ToggleButton)findViewById(R.id.numTgleBtn);
		strokeDollarView.useDirection(tglBtn.isChecked());
		tglBtn.setOnCheckedChangeListener(
			new CompoundButton.OnCheckedChangeListener()
			{
				public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
				{
					strokeDollarView.useDirection(isChecked);
				}
			}
		);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return super.onCreateOptionsMenu(menu);
	}

	@Override public boolean onPrepareOptionsMenu(Menu menu) {
		return super.onPrepareOptionsMenu(menu);
	}

	@Override
	public void onClick(View v)
	{
		switch( v.getId() )
		{
			case R.id.clear:
				strokeDollarView.clear();
				break;
			case R.id.recon:
				strokeDollarView.recognizeStrokes();
				break;
			case R.id.clearHist:
				strokeDollarView.clearPointHistory();
				break;
			case R.id.addButton:
			{
				EditText nameText = (EditText)findViewById(R.id.gestName);
				strokeDollarView.addStrokeSequence(
					nameText.getText().toString()
				);
				break;
			}	

			case R.id.writeXml:
			{
				Log.i("Dollar", "Made Here 2");
				EditText nameText = (EditText)findViewById(R.id.gestName);
				strokeDollarView.writeStrokeSequence(
					nameText.getText().toString()
				);
				break;
			}	
			default :
				break;
		}
	}

	@Override
	protected void onResume() {
		super.onResume();
		// If fading mode is enabled, then as long as we are resumed we want
		// to run pulse to fade the contents.
		ToggleButton tglBtn = (ToggleButton)findViewById(R.id.toggleButton2);
		doFading(tglBtn.isChecked());
	}

	@Override
	protected void onPause() {
		super.onPause();
		// Make sure to never run the fading pulse while we are paused or
		// stopped.
		doFading(false);
	}

	/*
	 * Stop the pulse to fade the screen.
	 */
	void doFading( boolean flag) {
		if( flag )
		{
			mHandler.removeMessages(FADE_MSG);
			mHandler.sendMessageDelayed(mHandler.obtainMessage(FADE_MSG), FADE_DELAY);

		} else {
			mHandler.removeMessages(FADE_MSG);
		}
	}

	private Handler mHandler = new Handler()
	{
		@Override public void handleMessage(Message msg) {
			switch (msg.what)
			{
				// Upon receiving the fade pulse, we have the view perform a
				// fade and then enqueue a new message to pulse at the desired
				// next time.
				case FADE_MSG:
				{
					//strokeDollarView.fade();
					mHandler.sendMessageDelayed(
					mHandler.obtainMessage(FADE_MSG), FADE_DELAY);
				}
					break;
				default:
					super.handleMessage(msg);
			}
		}
	};
}
